unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    MFile: TMenuItem;
    MOpen: TMenuItem;
    MCalc: TMenuItem;
    MSave: TMenuItem;
    Void1: TMenuItem;
    MQuit: TMenuItem;
    MHelp: TMenuItem;
    MAbout: TMenuItem;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    MCreate: TMenuItem;
    procedure Error (num,Lines:integer);
    function Put (Lines:integer;v:real):boolean;
    procedure MQuitClick(Sender: TObject);
    procedure MOpenClick(Sender: TObject);
    procedure MSaveClick(Sender: TObject);
    procedure MCalcClick(Sender: TObject);
    procedure MAboutClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MCreateClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const KSteps=5; {    x0..x5}

var
  Form1: TForm1;
  F:TextFile;
  S,S1,S2,S3:String;
  Var
  Uvb,Unb,Dno,Gp,m1,m2,b,Kfp,fip1,fip2,fip3,Cp1,Cp2,Cp3,GammaP1,GammaP2,GammaOs,
  GammaVod,n,Kdop,L,T :real;
  Var Hpr,Hpl,Bpl,H1,Q,DeltaLb,L1,Lg,beta,Lp,Rn,Rv,R,
   x1,x2,y1,y2,x3,y3,x0,y0,xm,ym,phi,x4,y4,x5,y5,a1,b1,xm2,ym2,r2,xn,yn,
   Bot,xx,x6,y6,xend,xstart,a2,b2,h01,h02,h03,sum1,sum2,sum3,Kust:real;
   i,imax,imin:integer;
   Var Rh1: array [1..6] of real=(
    1.1, 1.4, 1.9, 2.5, 3.3, 4.3
   );
   Var Rh2:array [1..6] of real=(
    2.2, 2.5, 3.2, 4.7, 5.8, 6.7
   );
   Var Hn,Zn1,Zn2,Zn3,Fin,Cn,sina,cosa,L_n,Gn,Pn: array [-50..50] of real;
   Var First:boolean;
   Var Readed:boolean;
implementation
uses About, Input;
{$R *.DFM}

procedure TForm1.MQuitClick(Sender: TObject);
begin
 Close;
end;

procedure TForm1.Error (num,Lines:integer);
var S,S2:String;
begin
 Str (Lines,S2);
 S:='   '+S2+'   '+OpenDialog1.FileName;
 case num of
  1: S:=S+' -  ';
  2: S:=S+' -    ';
  3: S:=S+' -    [1..10]';
 end;
 ShowMessage (S);
end;

function TForm1.Put (Lines:integer;v:real):boolean;
begin
 Put:=true;
 case Lines of
  1: Uvb:=v;
  2: Unb:=v;
  3: Dno:=v;
  4: Gp:=v;
  5: m1:=v;
  6: m2:=v;
  7: b:=v;
  8: Kfp:=v;
  9: fip1:=v;
  10: fip2:=v;
  11: fip3:=v;
  12: Cp1:=v;
  13: Cp2:=v;
  14: Cp3:=v;
  15: GammaP1:=v;
  16: GammaP2:=v;
  17: GammaOs:=v;
  18: GammaVod:=v;
  19: n:=v;
  20: Kdop:=v;
  21: L:=v;
  22: T:=v;
  23: Hpr:=v;
  else begin
   Error (3,Lines);
   Put:=false;
  end;
 end;
end;

procedure TForm1.MOpenClick(Sender: TObject);
var p,Lines,Code:integer;
 v:Real;
begin
 OpenDialog1.InitialDir:=GetCurrentDir;
 if OpenDialog1.Execute then begin
  AssignFile(F, OpenDialog1.FileName);
  Reset(F);
  Lines:=1;
  While not Eof (f) do begin
   Readln (F,S);
   p:=Pos (' ',s);
   if p=0 then begin
    Error (1,Lines);
    Exit;
   end;
   S2:=Copy (S,1,p-1);
   try
    v:=StrToFloat(s2);
   except
    on EOverflow do begin
     Error (2,Lines);
     Exit;
    end;
    on EConvertError do begin
     Error (2,Lines);
     Exit;
    end;
   end;
   if Put (Lines,v)=false then Exit;
   Inc (Lines);
  end;
  CloseFile(F);
  with DataForm do begin
   s2:=FloatToStrF(Uvb,ffFixed,15,2); Edit1.Text:=(Trim(s2));
   s2:=FloatToStrF(Unb,ffFixed,15,2); Edit2.Text:=(Trim(s2));
   s2:=FloatToStrF(Dno,ffFixed,15,2); Edit3.Text:=(Trim(s2));
   s2:=FloatToStrF(Gp,ffFixed,15,2); Edit4.Text:=(Trim(s2));
   s2:=FloatToStrF(m1,ffFixed,15,2); Edit5.Text:=(Trim(s2));
   s2:=FloatToStrF(m2,ffFixed,15,2); Edit6.Text:=(Trim(s2));
   s2:=FloatToStrF(b,ffFixed,15,2); Edit7.Text:=(Trim(s2));
   s2:=FloatToStrF(Kfp,ffFixed,15,9); Edit8.Text:=(Trim(s2));
   s2:=FloatToStrF(Fip1,ffFixed,15,2); Edit9.Text:=(Trim(s2));
   s2:=FloatToStrF(Fip2,ffFixed,15,2); Edit10.Text:=(Trim(s2));
   s2:=FloatToStrF(Fip3,ffFixed,15,2); Edit11.Text:=(Trim(s2));
   s2:=FloatToStrF(Cp1,ffFixed,15,2); Edit12.Text:=(Trim(s2));
   s2:=FloatToStrF(Cp2,ffFixed,15,2); Edit13.Text:=(Trim(s2));
   s2:=FloatToStrF(Cp3,ffFixed,15,2); Edit14.Text:=(Trim(s2));
   s2:=FloatToStrF(GammaP1,ffFixed,15,2); Edit15.Text:=(Trim(s2));
   s2:=FloatToStrF(GammaP2,ffFixed,15,2); Edit16.Text:=(Trim(s2));
   s2:=FloatToStrF(GammaOS,ffFixed,15,2); Edit17.Text:=(Trim(s2));
   s2:=FloatToStrF(GammaVod,ffFixed,15,2); Edit18.Text:=(Trim(s2));
   s2:=FloatToStrF(n,ffFixed,15,2); Edit19.Text:=(Trim(s2));
   s2:=FloatToStrF(Kdop,ffFixed,15,2); Edit20.Text:=(Trim(s2));
   s2:=FloatToStrF(L,ffFixed,15,2); Edit21.Text:=(Trim(s2));
   s2:=FloatToStrF(T,ffFixed,15,2); Edit22.Text:=(Trim(s2));
   s2:=FloatToStrF(Hpr,ffFixed,15,2); Edit23.Text:=(Trim(s2));
   ShowModal;
  end;
 end;
end;

function y(x:real):real;
var arg:real;
begin
 if x>L1 then y:=0
 else begin
  arg:=2*(q/Kfp)*(L1-x+Lg);
  y:=sqrt (arg);
 end;
end;

procedure Poisk (x1,y1,x2,y2,R:real;var x0,y0:real);
 {   2   r     }
var a0,a,b,c,rx1,ry1,rx2,ry2,d,rast:real;
begin
 a0:=(y2-y1)/(x2-x1);
 a:=a0;
 b:=-1;
 c:=-x1*a0+y1;
 rast:=sqrt(sqr(x1-x2)+sqr(y1-y2));
 d:=sqrt(sqr(r)-sqr(rast/2));
 rx1:=0.5*( (b*sqr(x1)-b*sqr(x2)+b*sqr(y1)-b*sqr(y2)-2*c*y2+2*c*y1+2*d*sqrt(sqr(a)+sqr(b))*y2-2*d*sqrt(sqr(a)+sqr(b))*y1) /
            (-x2*b+x1*b+y2*a-y1*a));
 ry1:=0.5*((-sqr(x1)*a+sqr(x2)*a-sqr(y1)*a+sqr(y2)*a+2*x2*c-2*x2*d*sqrt(sqr(a)+sqr(b))-2*x1*c+2*x1*d*sqrt(sqr(a)+sqr(b)) ) /
            (-x2*b+x1*b+y2*a-y1*a) );
 rx2:=-0.5*( (-b*sqr(x1)+b*sqr(x2)-b*sqr(y1)+b*sqr(y2)+2*c*y2-2*c*y1+2*d*sqrt(sqr(a)+sqr(b))*y2-2*d*sqrt(sqr(a)+sqr(b))*y1) /
            (-x2*b+x1*b+y2*a-y1*a));
 ry2:=-0.5*((sqr(x1)*a-sqr(x2)*a+sqr(y1)*a-sqr(y2)*a-2*x2*c-2*x2*d*sqrt(sqr(a)+sqr(b))+2*x1*c+2*x1*d*sqrt(sqr(a)+sqr(b)) ) /
            (-x2*b+x1*b+y2*a-y1*a) );
 if ry2>ry1 then begin
  x0:=rx2; y0:=ry2;
 end
 else begin
  x0:=rx1; y0:=ry1;
 end;
end;

function Tan2(x:real):real;
begin
 Tan2:=(sin(x)/cos(x))*(180/pi);
end;

procedure TForm1.MCalcClick(Sender: TObject); { }
var mindex:integer;
    a12,c12,dxn,KustMin,Rmin,rastr,temp:real;
begin
 Hpl:=Gp-Dno;
 Bpl:=Hpl*(m1+m2)+b;
 H1:=Uvb-Unb;
 beta:=m1/(2*m1+1);
 DeltaLb:=beta*h1;
 L1:=L+H1*m1;//!!!
 Lp:=L+DeltaLb;
 q:=kfp*sqr(h1)/(2*Lp);
 Lg:=0.5*q/Kfp;

 mindex:=Round(m2);
 Rn:=Rh1[mindex]*Hpl;
 Rv:=Rh2[mindex]*Hpl;
 R:=(Rn+Rv)/2;

 x1:=m1*Hpl+b;
 y1:=Hpl;
 //Str(x1:8:2,s1); Str(y1:8:2,s2); Memo1.Lines.Add ('x1='+s1+' y1='+s2);
 x2:=Bpl;
 y2:=0;
 //Str(x2:8:2,s1); Str(y2:8:2,s2); Memo1.Lines.Add ('x2='+s1+' y2='+s2);

 Poisk (x1,y1,x2,y2,R,x0,y0);
 //Str (x0:6:2,s1);  Str (y0:6:2,s2); Memo1.Lines.Add ('  2 '); Memo1.Lines.Add ('x0='+s1+' y0='+s2);

 xm:=(x1+x2)/2;
 ym:=(y1+y2)/2;
 phi:=85-arctan ((1/m2))*180/pi;
 x6:=xm+r*cos(phi)*pi/180;
 y6:=ym+r*sin(phi)*pi/180;
 //Str(x6:8:2,s1); Str(y6:8:2,s2); Memo1.Lines.Add ('x6='+s1+' y6='+s2);

 x3:=xm;
 y3:=ym+R;
 //Str(x3:8:2,s1); Str(y3:8:2,s2); Memo1.Lines.Add ('x3='+s1+' y3='+s2);

 xm2:=(xm+x0)/2;
 ym2:=(ym+y0)/2;
 r2:=sqrt(sqr(xm2-xm)+sqr(ym2-ym));
 x4:=xm+r2*cos(phi)*pi/180;
 y4:=ym+r2*sin(phi)*pi/180;
 //Str(x4:8:2,s1); Str(y4:8:2,s2); Memo1.Lines.Add ('x4='+s1+' y4='+s2);

 x5:=xm;
 y5:=ym+r2;
 //Str(x5:8:2,s1); Str(y5:8:2,s2); Memo1.Lines.Add ('x5='+s1+' y5='+s2);

 //  (x5,y5), (x0,y0)
 a1:=(y0-y5)/(x0-x5);
 b1:=y5-a1*x5;
 //Memo1.Lines.Add (' '); Str(a1:8:2,s1); Str(b1:8:2,s2);
 //Memo1.Lines.Add ('y ='+s1+'*x+('+s2+')');
 //Memo1.Lines.Add (' ');  Str(Rn:8:2,s1); Str(Rv:8:2,s2);
 //Memo1.Lines.Add ('Rn ='+s1+' Rv ='+s2);
 {xn  x0,y0 -  x5,y5  
    xn   
   R= yn+T
   R=R-0,5
       (x1,y1)-(x2,y2)
    R  
 }
 // :
 Memo1.Lines.Clear;
 Memo1.Lines.Add (' ');
 Memo1.Lines.Add ('');
 s2:=FloatToStrF(Uvb,ffFixed,15,2); Memo1.Lines.Add(Trim(s2)+' ;Uvb');
 s2:=FloatToStrF(Unb,ffFixed,15,2); Memo1.Lines.Add(Trim(s2)+' ;Unb');
 s2:=FloatToStrF(Dno,ffFixed,15,2); Memo1.Lines.Add(Trim(s2)+' ;Dno');
 s2:=FloatToStrF(Gp,ffFixed,15,2); Memo1.Lines.Add(Trim(s2)+' ;Gp');
 s2:=FloatToStrF(m1,ffFixed,15,2); Memo1.Lines.Add(Trim(s2)+' ;m1');
 s2:=FloatToStrF(m2,ffFixed,15,2); Memo1.Lines.Add(Trim(s2)+' ;m2');
 s2:=FloatToStrF(b,ffFixed,15,2); Memo1.Lines.Add(Trim(s2)+' ;b');
 s2:=FloatToStrF(Kfp,ffFixed,15,9); Memo1.Lines.Add(Trim(s2)+' ;Kfp3');
 s2:=FloatToStrF(Fip1,ffFixed,15,2); Memo1.Lines.Add(Trim(s2)+' ;fip1');
 s2:=FloatToStrF(Fip2,ffFixed,15,2); Memo1.Lines.Add(Trim(s2)+' ;fip2');
 s2:=FloatToStrF(Fip3,ffFixed,15,2); Memo1.Lines.Add(Trim(s2)+' ;fip3');
 s2:=FloatToStrF(Cp1,ffFixed,15,2); Memo1.Lines.Add(Trim(s2)+' ;Cp1');
 s2:=FloatToStrF(Cp2,ffFixed,15,2); Memo1.Lines.Add(Trim(s2)+' ;Cp2');
 s2:=FloatToStrF(Cp3,ffFixed,15,2); Memo1.Lines.Add(Trim(s2)+' ;Cp2');
 s2:=FloatToStrF(GammaP1,ffFixed,15,2); Memo1.Lines.Add(Trim(s2)+' ;GammaP1');
 s2:=FloatToStrF(GammaP2,ffFixed,15,2); Memo1.Lines.Add(Trim(s2)+' ;GammaP2');
 s2:=FloatToStrF(GammaOS,ffFixed,15,2); Memo1.Lines.Add(Trim(s2)+' ;GammaOS');
 s2:=FloatToStrF(GammaVod,ffFixed,15,2); Memo1.Lines.Add(Trim(s2)+' ;GammaOS');
 s2:=FloatToStrF(n,ffFixed,15,2); Memo1.Lines.Add(Trim(s2)+' ;n');
 s2:=FloatToStrF(Kdop,ffFixed,15,2); Memo1.Lines.Add(Trim(s2)+' ;Kdop');
 s2:=FloatToStrF(L,ffFixed,15,2); Memo1.Lines.Add(Trim(s2)+' ;L');
 s2:=FloatToStrF(T,ffFixed,15,2); Memo1.Lines.Add(Trim(s2)+' ;T');
 s2:=FloatToStrF(Hpr,ffFixed,15,2); Memo1.Lines.Add(Trim(s2)+' ;Hpr'); 
 Memo1.Lines.Add ('');
 Memo1.Lines.Add (' ');

 //  (x1,y1), (x2,y2)   
 a12:=(y2-y1)/(x2-x1);
 c12:=y1-a12*x1;
 dxn:=(x0-x5)/kSteps;
 xn:=x5;
 while abs(xn-x0)>1e-3 do begin
  yn:=a1*xn+b1;
  R:=yn+T;
  KustMin:=1e38;
  Rmin:=R;
  rastr:=abs(a12*xn-yn+c12)/sqrt(sqr(a12)+1);
  repeat
   Bot:=R/n;

   temp:=-sqr(Hpl)+sqr(R)-sqr(yn)+2*yn*Hpl;
   if temp<0 then break; //!!!
   xend:=xn-sqrt(temp);
   temp:=-sqr(yn)+sqr(r);
   if temp<0 then break; //!!!
   xstart:=xn+sqrt(temp);
   //  (x1,y1), (x2,y2)
   a2:=(y2-y1)/(x2-x1);
   b2:=y2-a2*x2;

   xx:=xn;
   i:=0;
   while xx>xend do begin
    H01:=a2*xx+b2;
    if H01>Hpl then H01:=Hpl;
    H02:=y(xx);
    H03:=yn-sqrt(-sqr(xn)+2*xn*xx-sqr(xx)+sqr(r));
    if H02+1.5*Hpr > H01 then begin
     ShowMessage ('   L!  .      ');
     Exit;
    end;
    if (H02>=H03) and (H02<H01) then Zn1[i]:=H01-H02; Cn[i]:=0;
    if (H02<H03) and (H03<H01) then Zn1[i]:=H01-H03; Cn[i]:=Cp1;
    if (H02<=H03) and (H01>H03) then Zn2[i]:=0; Cn[i]:=0;
    if (H02>H03) and (H01>H02) then Zn2[i]:=H02-H03; Cn[i]:=Cp2;
    if H03<0 then Zn3[i]:=-H03 else Zn3[i]:=0; Cn[i]:=Cp3;

    Fin[i]:=(fip1*Zn1[i]+fip2*Zn2[i]+fip3*Zn3[i])/(Zn1[i]+Zn2[i]+Zn3[i]);
    sina[i]:=i/N;
    cosa[i]:=sqrt(1-sqr(i/N));
    L_n[i]:=Bot/cosa[i];
    Gn[i]:=Bot*(Zn1[i]*Gammap1+Zn2[i]*Gammap2+Zn3[i]*Gammaos);
    Pn[i]:=(Zn2[i]+Zn3[i])*GammaVod;

    i:=i+1;
    xx:=xx-Bot;
   end;
   imax:=i-1;

   //    
   i:=-1;
   xx:=xn+Bot;
   while xx<xstart do begin
    H01:=a2*xx+b2;
    if H01>Hpl then H01:=Hpl;
    H02:=y(xx);
    H03:=yn-sqrt(-sqr(xn)+2*xn*xx-sqr(xx)+sqr(r));
    if (H02>=H03) and (H02<H01) then Zn1[i]:=H01-H02; Cn[i]:=0;
    if (H02<H03) and (H03<H01) then Zn1[i]:=H01-H03; Cn[i]:=Cp1;
    if (H02<=H03) and (H01>H03) then Zn2[i]:=0; Cn[i]:=0;
    if (H02>H03) and (H01>H02) then Zn2[i]:=H02-H03; Cn[i]:=Cp2;
    if H03<0 then Zn3[i]:=-H03 else Zn3[i]:=0; Cn[i]:=Cp3;

    Fin[i]:=(fip1*Zn1[i]+fip2*Zn2[i]+fip3*Zn3[i])/(Zn1[i]+Zn2[i]+Zn3[i]);
    sina[i]:=i/N;
    cosa[i]:=sqrt(1-sqr(i/N));
    L_n[i]:=Bot/cosa[i];
    Gn[i]:=Bot*(Zn1[i]*Gammap1+Zn2[i]*Gammap2+Zn3[i]*Gammaos);
    Pn[i]:=(Zn2[i]+Zn3[i])*GammaVod;

    i:=i-1;
    xx:=xx+Bot;
   end;
   imin:=i+1;

   sum1:=0; sum2:=0; sum3:=0;
   //Memo1.Lines.Add ('  P(n)      G(n)          L(n)    ');

   for i:=imin to imax do begin
    sum1:=sum1+(Gn[i]*cosa[i]-Pn[i]*L_n[i])*sin(Fin[i]*pi/180)/cos(Fin[i]*pi/180);
    sum2:=sum2+Cn[i]*L_n[i];
    sum3:=sum3+Gn[i]*sina[i];

    //Str(i:5,  S);    Str(Pn[i]:10:2,  S1);
    //Str(Gn[i]:10:2,  S2);    Str(L_n[i]:10:2,  S3);
    //Memo1.Lines.Add (s+s1+s2+s3);
   end;
   Kust:=(sum1+sum2)/sum3;
   //Str(Kust:8:2,S);   Memo1.Lines.Add ('.='+s);
   if Kust<Kustmin then begin
    KustMin:=Kust;
    Rmin:=R;
   end;
   r:=r-0.5;
   if r<rastr then break;
  until false;
  Memo1.Lines.Add ('');
  s1:=Trim(FloatToStrF (xn,ffFixed,15,3));
  s2:=Trim(FloatToStrF (Rmin,ffFixed,15,3));
  Memo1.Lines.Add ('x='+s1+#9+#9+'Rmin='+s2);
  s1:=Trim(FloatToStrF (yn,ffFixed,15,3));
  s2:=Trim(FloatToStrF (Kustmin,ffFixed,15,3));
  Memo1.Lines.Add ('y='+s1+#9+#9+'Kust='+s2);
  xn:=xn+dxn;
 end;
 MSave.Enabled:=True;
end;

procedure TForm1.MSaveClick(Sender: TObject);
var Ext:String;
 l:Longint;
begin
 SaveDialog1.InitialDir:=GetCurrentDir;
 if SaveDialog1.Execute then begin
  Ext := ExtractFileExt(SaveDialog1.FileName);
  if Ext='' then SaveDialog1.FileName:=SaveDialog1.FileName+'.txt';
  AssignFile(F, SaveDialog1.FileName);
  ReWrite(F);
  For l:=0 to Memo1.Lines.Count-1 do begin
   Writeln (F,Memo1.Lines.Strings[l]);
  end;
  CloseFile(F);
  ShowMessage ('     '+SaveDialog1.FileName);
 end;
end;

procedure TForm1.MAboutClick(Sender: TObject);
begin
 with TAboutBox.Create(Self) do
 try
   ShowModal;
 finally
   Free;
 end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
 if First then MAboutClick(Form1)
 else First:=false;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 First:=true;
 Readed:=false;
end;

procedure TForm1.MCreateClick(Sender: TObject);
begin
 with DataForm do begin
  Edit1.Text:=''; Edit2.Text:=''; Edit3.Text:=''; Edit4.Text:='';
  Edit5.Text:=''; Edit6.Text:=''; Edit7.Text:=''; Edit8.Text:='';
  Edit9.Text:=''; Edit10.Text:=''; Edit11.Text:=''; Edit12.Text:='';
  Edit13.Text:=''; Edit14.Text:=''; Edit15.Text:=''; Edit16.Text:='';
  Edit17.Text:=''; Edit18.Text:=''; Edit19.Text:=''; Edit20.Text:='';
  Edit21.Text:=''; Edit22.Text:=''; Edit23.Text:='';
  ShowModal;
 end;
end;

end.
